<template>
  <div class="rightContent">
    <div class="top">
      <SearchCommonView :add-title="'新建'" :showAdd="false" :placeholder="'请输入产品编码/产品名称搜索'" :amount-view="false"
         @searchClick="getList" >
        <template slot="leftButton">
          <el-date-picker
                    v-model="monthBoundObject.date"
                    value-format="yyyy-MM"
                    type="month"
                    :clearable='false'
                    class='margin_left_20px'
                    @change='getData'
                    placeholder="选择日期"
                    :picker-options="pickerOptions"
                  >
          </el-date-picker>
        </template>
      </SearchCommonView>
    </div>
    <div class="list-view">
      <div class="table">
        <TableCommonView ref="tableListRef" :loading="isTableOneLoading" :table-list="tableList" :showCheckcol='false' @selTableCol="selTableCol">
          <template slot="tableButton">
              <el-table-column label="期初库存" prop='inventoryStart'>
                <el-table-column label="件" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.beginMoreUnitsArr,'件',scope.row.beginAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="匹" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.beginMoreUnitsArr,'匹',scope.row.beginAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="米数" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.beginMoreUnitsArr,'米数',scope.row.beginAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="重量" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.beginMoreUnitsArr,'重量',scope.row.beginAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
              </el-table-column>
              <el-table-column label="本月入库" prop='inInventoryCurrentMonth'>
                <el-table-column label="件" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.inputMoreUnitsArr,'件',scope.row.inputAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="匹" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.inputMoreUnitsArr,'匹',scope.row.inputAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="米数" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.inputMoreUnitsArr,'米数',scope.row.inputAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="重量" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.inputMoreUnitsArr,'重量',scope.row.inputAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
              </el-table-column>
              <el-table-column label="本月出库" prop='outInventoryCurrentMonth'>
                <el-table-column label="件" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.outputMoreUnitsArr,'件',scope.row.outputAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="匹" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.outputMoreUnitsArr,'匹',scope.row.outputAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="米数" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.outputMoreUnitsArr,'米数',scope.row.outputAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="重量" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.outputMoreUnitsArr,'重量',scope.row.outputAmount,scope.row.unit)}}
                  </template>
                </el-table-column>
              </el-table-column>
              <el-table-column label="期末库存" prop='inventoryEnd'>
                <el-table-column label="件" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.MoreUnitsArr,'件',scope.row.amount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="匹" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.MoreUnitsArr,'匹',scope.row.amount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="米数" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.MoreUnitsArr,'米数',scope.row.amount,scope.row.unit)}}
                  </template>
                </el-table-column>
                <el-table-column label="重量" prop='inventoryStart' min="90">
                  <template slot-scope="scope">
                    {{getUnitValue(scope.row.MoreUnitsArr,'重量',scope.row.amount,scope.row.unit)}}
                  </template>
                </el-table-column>
              </el-table-column>
            </template>
        </TableCommonView>
      </div>
      <div class="btn-pager">
        <PagerView class="page" :pager-options="pagerOptions" v-on="pagerEvents" />
      </div>
    </div>
    </div>
</template>

<script>

import pageMixin from "@/components/makepager/pager/mixin/pageMixin"
import { getmonthStats } from "@/api/reportForm/inventoryRwport"
import newDate from "@/api/date";
const { getPreviousMonth,formatTime} = newDate;
export default {
  name: "outboundDetail",
  props: {},
  components: {  },
  mixins: [pageMixin],
  computed: {},
  data() {
    return {
      monthBoundObject:{
        keyWord:'',
        date:getPreviousMonth(),
      },
      tableList: {},
      showcol: [],
      pickerOptions: {
        disabledDate(time) {
          return time.getTime() > formatTime(getPreviousMonth());
        },
      },
      isTableOneLoading: false,
    }
  },
  created() {
    this.setTable()
    this.getData()
  },
  methods: {
    getUnitValue(list,val,num,unit){
      let  string='--'
      if(list){
        if(list.length>0){
          for(let i in list){
            if(list[i].unit==val){
              string=list[i].amount
              break;
            }
          }
        }
      }
      if(unit==val){
        string=num
      }
      return string
    },
    setTable() {
      this.tableList = {
        tableInfomation: [],
        selectBox: false,
        selectIndex:true,
        showcol: this.showcol,
        allcol: [],
        tableColumn: this.setTableColumn(this.showcol)
      }
      let allcol = []
      for (let i = 0; i < this.tableList.tableColumn.length; i++) {
        if (!this.tableList.tableColumn[i].default) {
          const label = this.tableList.tableColumn[i].label
          allcol.push(label)
        }
      }
      this.tableList.allcol = allcol
    },
    setTableColumn() {
      let tableColumn = [
        {
          label: "产品编码",
          prop: "productId",
          min:110,
          isShowColumn: true,
          default: true
        },
        {
          label: "产品名称",
          prop: "productName",
          min:110,
          isShowColumn: true,
          default: true
        },
      ]
      return tableColumn
    },
    selTableCol(val) {
      this.showcol = val
      this.tableList.tableColumn = this.setTableColumn(val)
    },
    // 库存报表跳转请求数据
    async getData() {
      this.isTableOneLoading = true;
        await getmonthStats({
          date:this.monthBoundObject.date,
          keyword: this.monthBoundObject.keyWord,
          page: this.pagerOptions.currPage,
          pageSize: this.pagerOptions.pageSize
        }).then((res) => {
          if (res.code == 200&&res.data) {
            this.tableList.tableInfomation = res.data||[]
          }else{
            this.tableList.tableInfomation = res.data||[]
          }
          this.pagerOptions.totalCount = res.total
          this.isTableOneLoading = false;
        })
      
    },
    // 搜索
    getList(val) {
      this.monthBoundObject.keyWord = val;
      this.getData()
    },
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style lang="scss" scoped></style>
